



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android 布局学习之——Layout(布局)具体解释二（常见布局和布局參数）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android 布局学习之——Layout(布局)具体解释二（常见布局和布局參数）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 01:39:19 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>
<p><strong>&nbsp;[Android布局学习系列]</strong></p>
<p><strong>&nbsp; 1.<a href="http://www.cnblogs.com/JohnTsai/p/4090539.html" rel="external nofollow noreferrer">Android 布局学习之——Layout(布局)具体解释一</a></strong></p>
<p><strong>&nbsp; 2.<a href="http://www.cnblogs.com/JohnTsai/p/4093278.html" rel="external nofollow noreferrer">Android 布局学习之——Layout(布局)具体解释二（常见布局和布局參数）</a></strong></p>
<p><strong>&nbsp; 3.<a href="http://www.cnblogs.com/JohnTsai/p/4077183.html" rel="external nofollow noreferrer">Android 布局学习之——LinearLayout的layout_weight属性</a></strong></p>
<p><strong>&nbsp; 4.<a href="http://www.cnblogs.com/JohnTsai/p/4074643.html" rel="external nofollow noreferrer">Android 布局学习之——LinearLayout属性baselineAligned的作用及baseline</a></strong></p>
<p><strong>&nbsp;&nbsp; Layout Parameters（布局參数）：</strong></p>
<p>在XML文件里，我们常常看到类&#20284;与<strong>layout_width</strong>这种<strong>布局属性</strong>（layout attributes），这些属性用来定义</p>
<p>View的布局參数，为了让它适合于ViewGroup。</p>
<p>每一个ViewGroup类都实现了一个继承自ViewGroup.LayoutParams的嵌套类。</p>
<p>子类包括定义每一个子View<strong>大小和位置</strong>的属性类型，为了适应于ViewGroup。</p>
<p>以下通过官方文档的一张图片以及一个XML文件来学习一下：</p>
<p><img referrerpolicy="no-referrer"src=""></p>
<div>
<div>
<img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums"> 1 &lt;!-- activity的根布局是LinearLayout 也就是线性布局 --&gt;<br />
 2 &lt;LinearLayout xmlns:android=&quot;http://schemas.android.com/apk/res/android&quot;<br />
 3     xmlns:tools=&quot;http://schemas.android.com/tools&quot;<br />
 4     android:layout_width=&quot;match_parent&quot;<br />
 5     android:layout_height=&quot;wrap_content&quot;<br />
 6     android:background=&quot;#0f0&quot;<br />
 7     android:orientation=&quot;vertical&quot; &gt;<br />
 8     &lt;!-- LinearLayout有个子View是RelativeLayout --&gt;<br />
 9     &lt;RelativeLayout<br />
10       android:layout_width=&quot;wrap_content&quot;<br />
11       android:layout_height=&quot;wrap_content&quot;<br />
12       android:background=&quot;#f00&quot;<br />
13       &gt;<br />
14       &lt;TextView<br />
15           android:id=&quot;@&#043;id/textView1InRL&quot;<br />
16           android:background=&quot;#fff&quot;<br />
17           android:layout_width=&quot;wrap_content&quot;<br />
18           android:layout_height=&quot;wrap_content&quot;<br />
19           android:text=&quot;TextView&quot; /&gt;<br />
20<br />
21     &lt;TextView<br />
22         android:id=&quot;@&#043;id/textView2InRL&quot;<br />
23         android:background=&quot;#fff&quot;<br />
24         android:layout_width=&quot;wrap_content&quot;<br />
25         android:layout_height=&quot;wrap_content&quot;<br />
26         android:text=&quot;TextView2&quot;<br />
27         android:layout_toRightOf=&quot;@id/textView1InRL&quot;<br />
28          /&gt;<br />
29      &lt;TextView<br />
30         android:background=&quot;#fff&quot;<br />
31         android:layout_width=&quot;wrap_content&quot;<br />
32         android:layout_height=&quot;wrap_content&quot;<br />
33         android:text=&quot;TextView3&quot;<br />
34         android:layout_below=&quot;@id/textView2InRL&quot;<br />
35          /&gt;<br />
36       &lt;/RelativeLayout&gt;<br />
37       &lt;Button<br />
38           android:text=&quot;Button1InLinearLayout&quot;<br />
39           android:layout_width=&quot;wrap_content&quot;<br />
40           android:layout_height=&quot;wrap_content&quot;<br />
41           /&gt;<br />
42       &lt;Button<br />
43           android:text=&quot;Button2InLinearLayout&quot;<br />
44           android:layout_width=&quot;wrap_content&quot;<br />
45           android:layout_height=&quot;wrap_content&quot;<br />
46           /&gt;<br />
47 &lt;/LinearLayout&gt;</pre>
<div>
<img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
</div>
<p><img referrerpolicy="no-referrer"src=""></p>
<p>从上，我们能够看出。布局中的子元素都必须定义使他合适于它的父布局的布局參数，虽然它可能为它的子元素定义不同的布局參数。比方上图中的RelativeLayout,它受父Layout：LinearLayout影响，然后它的布局參数则影响到了它的子元素：三个TextView。</p>
<p><strong>&nbsp;&nbsp; 常见的布局（Common Layouts）:</strong></p>
<p>以下介绍Android中经常使用的布局：</p>
<p>1.线性布局（Linear Layout）</p>
<p>将子元素按<strong><em>垂直方向</em></strong>或<em><strong>水平方向</strong></em>线性排列。（假设窗体的长度超过了屏幕的长度，则能够生成一个滚动栏）</p>
<p><img referrerpolicy="no-referrer"src=""></p>
<p>窗体长度超过屏幕长度，生成滚动栏（srollbar）的方法：</p>
<p>用ScrollView包裹线性布局：</p>
<div>
<div>
<img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums"> 1 &lt;LinearLayout<br />
 2        android:layout_width=&quot;fill_parent&quot;<br />
 3        android:layout_height=&quot;fill_parent&quot;<br />
 4        xmlns:android=&quot;http://schemas.android.com/apk/res/android&quot;&gt;<br />
 5        &lt;ScrollView<br />
 6             android:layout_width=&quot;fill_parent&quot;<br />
 7             android:layout_height=&quot;wrap_content&quot;&gt;<br />
 8             &lt;LinearLayout<br />
 9                   android:layout_width=&quot;wrap_content&quot;<br />
10                   android:layout_height=&quot;wrap_content&quot;<br />
11                   android:orientation=&quot;vertical&quot;&gt;<br />
12                   &lt;!-- 这里放线性布局中的内容 --&gt;<br />
13             &lt;/LinearLayout&gt;<br />
14       &lt;/ScrollView&gt;<br />
15  &lt;/LinearLayout&gt;</pre>
<div>
<img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
</div>
<p>通过一个样例来深入学习一下线性布局：</p>
<div>
<div>
<img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums"> 1 &lt;LinearLayout xmlns:android=&quot;http://schemas.android.com/apk/res/android&quot;<br />
 2     xmlns:tools=&quot;http://schemas.android.com/tools&quot;<br />
 3     android:layout_width=&quot;match_parent&quot;<br />
 4     android:layout_height=&quot;wrap_content&quot;<br />
 5     android:paddingLeft=&quot;20dp&quot;<br />
 6     android:paddingRight=&quot;20dp&quot;<br />
 7     android:orientation=&quot;vertical&quot; &gt;<br />
 8     &lt;ScrollView<br />
 9         android:layout_width=&quot;fill_parent&quot;<br />
10         android:layout_height=&quot;wrap_content&quot;<br />
11         &gt;<br />
12         &lt;LinearLayout<br />
13             android:layout_width=&quot;wrap_content&quot;<br />
14             android:layout_height=&quot;wrap_content&quot;<br />
15             android:orientation=&quot;vertical&quot;<br />
16             &gt;<br />
17     &lt;EditText<br />
18         android:layout_width=&quot;match_parent&quot;<br />
19         android:layout_height=&quot;wrap_content&quot;<br />
20         android:hint=&quot;帐号:&quot; /&gt;<br />
21     &lt;EditText<br />
22         android:layout_width=&quot;match_parent&quot;<br />
23         android:layout_height=&quot;wrap_content&quot;<br />
24         android:hint=&quot;password:&quot; /&gt;<br />
25     &lt;LinearLayout<br />
26         android:layout_width=&quot;wrap_content&quot;<br />
27         android:layout_height=&quot;wrap_content&quot;<br />
28         android:orientation=&quot;horizontal&quot;<br />
29         &gt;<br />
30         &lt;Button<br />
31            android:layout_width=&quot;wrap_content&quot;<br />
32            android:layout_height=&quot;wrap_content&quot;<br />
33            android:layout_marginLeft=&quot;30dp&quot;<br />
34            android:text=&quot;登录&quot;<br />
35             /&gt;<br />
36           &lt;Button<br />
37            android:layout_width=&quot;wrap_content&quot;<br />
38            android:layout_height=&quot;wrap_content&quot;<br />
39            android:layout_marginLeft=&quot;100dp&quot;<br />
40            android:text=&quot;注冊&quot;<br />
41             /&gt;<br />
42     &lt;/LinearLayout&gt;<br />
43     &lt;ImageView<br />
44         android:layout_width=&quot;match_parent&quot;<br />
45         android:layout_height=&quot;500dp&quot;<br />
46         android:src=&quot;@drawable/ic_launcher&quot;<br />
47         /&gt;<br />
48     &lt;TextView<br />
49         android:layout_width=&quot;match_parent&quot;<br />
50         android:layout_height=&quot;wrap_content&quot;<br />
51         android:text=&quot;LinearLayout大小超过屏幕大小的測试&quot;<br />
52         /&gt;<br />
53     &lt;/LinearLayout&gt;<br />
54     &lt;/ScrollView&gt;<br />
55 &lt;/LinearLayout&gt;</pre>
<div>
<img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/634832/201411/121843584916372.gif"></p>
<p>2.相关布局（Relative Layout）</p>
<p>正如其名，相关布局。我们能够通过让子元素互相相关（比方Button A在TextView B的以下）或与父母相关来指定</p>
<p>它们的位置。</p>
<p><img referrerpolicy="no-referrer"src=""></p>
<p>默认地，全部的子View都被放置在布局的左上方（top-left）。</p>
<p>设置子View之间和子View与父母之间关系的參数例如以下图所看到的：</p>
<p><img referrerpolicy="no-referrer"src=""></p>
<p>相同通过一个样例来学习一下相关布局：</p>
<div>
<div>
<img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
<pre class="prettyprint linenums"> 1 &lt;RelativeLayout xmlns:android=&quot;http://schemas.android.com/apk/res/android&quot;<br />
 2     xmlns:tools=&quot;http://schemas.android.com/tools&quot;<br />
 3     android:layout_width=&quot;match_parent&quot;<br />
 4     android:layout_height=&quot;match_parent&quot;<br />
 5     tools:context=&quot;.MainActivity&quot; &gt;<br />
 6<br />
 7     &lt;!--android:layout_centerHorizontal 设置TextView在水平中心--&gt;<br />
 8         &lt;TextView<br />
 9             android:id=&quot;@&#043;id/login&quot;<br />
10             android:layout_width=&quot;wrap_content&quot;<br />
11             android:layout_height=&quot;wrap_content&quot;<br />
12             android:layout_centerHorizontal=&quot;true&quot;<br />
13             android:textSize=&quot;20sp&quot;<br />
14             android:text=&quot;登录界面&quot; /&gt;<br />
15      &lt;!--android:layout_marginTop=&quot;24dp&quot; 设置了EditText的顶部上面的空暇空间是24dp --&gt;<br />
16     &lt;EditText<br />
17         android:id=&quot;@&#043;id/editText1&quot;<br />
18         android:layout_width=&quot;wrap_content&quot;<br />
19         android:layout_height=&quot;wrap_content&quot;<br />
20         android:layout_below=&quot;@id/login&quot;<br />
21         android:layout_centerHorizontal=&quot;true&quot;<br />
22         android:layout_marginTop=&quot;24dp&quot;<br />
23         android:hint=&quot;username&quot;<br />
24         android:ems=&quot;10&quot; &gt;<br />
25<br />
26         &lt;requestFocus /&gt;<br />
27     &lt;/EditText&gt;<br />
28     &lt;!-- android:layout_below=&quot;@&#043;id/editText1&quot;editText2在editText1以下 --&gt;<br />
29     &lt;EditText<br />
30         android:id=&quot;@&#043;id/editText2&quot;<br />
31         android:layout_width=&quot;wrap_content&quot;<br />
32         android:layout_height=&quot;wrap_content&quot;<br />
33         android:layout_below=&quot;@&#043;id/editText1&quot;<br />
34         android:layout_centerHorizontal=&quot;true&quot;<br />
35         android:layout_marginTop=&quot;27dp&quot;<br />
36         android:ems=&quot;10&quot;<br />
37         android:hint=&quot;password&quot;<br />
38         android:inputType=&quot;textPassword&quot; /&gt;<br />
39       &lt;!--  android:layout_alignRight=&quot;@id/editText2&quot;设置cancelButton与<br />
40          editText2的右边缘对齐--&gt;<br />
41     &lt;Button<br />
42         android:id=&quot;@&#043;id/cancelButton&quot;<br />
43         android:layout_width=&quot;wrap_content&quot;<br />
44         android:layout_height=&quot;wrap_content&quot;<br />
45         android:layout_below=&quot;@id/editText2&quot;<br />
46         android:layout_alignRight=&quot;@id/editText2&quot;<br />
47         android:text=&quot;取消&quot;<br />
48         /&gt;<br />
49        &lt;!--  android:layout_toLeftOf=&quot;@id/cancelButton&quot;设置确定button在取消button的左边 --&gt;<br />
50         &lt;Button<br />
51         android:id=&quot;@&#043;id/confirmButton&quot;<br />
52         android:layout_width=&quot;wrap_content&quot;<br />
53         android:layout_height=&quot;wrap_content&quot;<br />
54         android:layout_below=&quot;@id/editText2&quot;<br />
55         android:layout_toLeftOf=&quot;@id/cancelButton&quot;<br />
56         android:text=&quot;确定&quot;<br />
57         /&gt;<br />
58<br />
59 &lt;/RelativeLayout&gt;</pre>
<div>
<img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif"></div>
</div>
<p><img referrerpolicy="no-referrer"src=""></p>
<p>希望这篇文章对大家的学习有所帮助，假设你喜欢，请推荐一下，谢谢~</p>
<p>假设转载，请在文章开头处注明本博客地址:<a href="http://www.cnblogs.com/JohnTsai/p/www.cnblogs.com/JohnTsai" rel="external nofollow noreferrer">http:www.cnblogs.com/JohnTsai</a></p>
<p>欢迎讨论交流，邮箱:JohnTsai.Work@gmail.com ：）</p>
</div>
<div>
</div>
<div>
<div></div>
<div>标签:&nbsp;<a href="http://www.cnblogs.com/JohnTsai/tag/Android/" rel="external nofollow noreferrer">Android</a>,&nbsp;<a href="http://www.cnblogs.com/JohnTsai/tag/Layout/" rel="external nofollow noreferrer">Layout</a></div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q26dv97.html">ABP框架 - 领域事件（EventBus）</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mdpz28.html">Node&period;js入门学习笔记（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/390pkom8.html">linux下bom头导致的php调用php接口 返回的json字符串 无法转成 数组，即json字符串无法解码的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4dndnq.html">css secrets----multiple borders</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq115p2q.html">ASP&period;NET MVC4 数据库连接&lpar;EF6&period;0&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zm4g59.html">【python cookbook】【数据结构与算法】15&period;根据字段将记录分组</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1gmvx9.html">C&num;开发COM组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xxxng9.html">html之a标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde5vkv9.html">synchronized内置锁</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xzp368.html">python中那些双下划线开头得函数和变量--转载</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w6j4wq.html">jbpm入门样例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1xddd9.html">radio组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v07yj8.html">zz android 系统 makefile文件（Android&period;mk）组织结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn3rrrq.html">sqlite数据库方言配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x4ekm8.html">weblogic配置jdbc数据源</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0yg0eq.html">&period;NET&lpar;C&num;&rpar;：XmlReader和Whitespace以及MoveToContent和ReadToFollowing方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpjzk79.html">POJ 2337 输出欧拉路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1lvvyq.html">MySQL字段操作与数据处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgj2gr8.html">Oracle exp和expdp对数据进行备份</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll5jeeq.html">windows下java环境变量的配置 javac不是内部或外部命令的问题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdppzovq.html">air mobile andriod ios 页面加载控件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkk5pd8.html">swift 笔记 &lpar;十二&rpar; &mdash;&mdash; 下标</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjjwxr8.html">QlikView同button控制转换图表类型&lpar;例如，变成一个垂直的条形图&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kkyx09.html">【Java GUI】Java面板基础：JPanel</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkkzjv8.html">poj 4088&colon;Set操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzzxgw8.html">Raw-OS互斥的源代码分析的量的Mutex</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rggwrr8.html">设计模式模式游客&lpar;Visitor&rpar;摘录</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojjoplq.html">Java重写round&lpar;&rpar;方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zz5p39.html">MVC5个人用户账户身份验证集成google和facebook的OAuth2登陆</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rggpvr8.html">AFNetworking框架&lowbar;上传文件或图像server</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
